<?php

namespace Insign\PostCore\Block\Adminhtml\Barcode;

use Magento\Backend\Block\Template;
use Magento\Backend\Block\Template\Context;
use Magento\Checkout\Model\Session;
use Magento\Framework\Exception\NoSuchEntityException;
use Magento\Framework\UrlInterface;

class MassPrint extends Template
{
    /**
     * @var Session
     */
    private $barcodeSession;
    /**
     * @var array
     */
    private $data;
    /**
     * @var UrlInterface
     */
    private $url;

    /**
     * MassPrint constructor.
     * @param Context $context
     * @param Session $barcodeSession
     * @param UrlInterface $url
     * @param array $data
     */
    public function __construct(
        Context $context,
        Session $barcodeSession,
        UrlInterface $url,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->barcodeSession = $barcodeSession;
        $this->url = $url;
    }

    /**
     * @return array
     * @throws NoSuchEntityException
     */
    public function getBarcodes(): array
    {
        $currentStore = $this->_storeManager->getStore();
        $barcodesArray = [];
        $barcodes = $this->barcodeSession->getVarValue();
        if (isset($barcodes)) {
            foreach ($barcodes as $barcode) {
                array_push($barcodesArray, substr($currentStore->getBaseUrl(UrlInterface::URL_TYPE_MEDIA), 0, -1) . $barcode);
            }
            return $barcodesArray;
        }
    }
}
